/* Copyright (C) 2001,2008 Martijn van Iersel and Jules Beulen
 * This program is released under the terms of the zlib license
 * See license.txt for details
 */
#include "msg.h"
#include <gstream.h>
#include <gmanip.h>

char const * const msgs[3] =
     {"",
     "Move the free piece with LEFT/RIGHT. Rotate the piece with UP/DOWN. Press enter when done.",
     "Use the cursor keys to move your guy to your treasure"};

void Messager::activate ()
{
    current_message = 0;
    message_timer = -1;
}

void Messager::setMessage (int index, int time)
{
    if (index >= 3)
        return;

    current_message = index;
    message_timer = time;
}

int Messager::getMessage ()
{
    return current_message;
}

void Messager::update ()
{
    if (message_timer > 0)
    {
        message_timer--;
        if (message_timer == 0)
        {
            current_message = 0;
        }
    }
}

void Messager::draw (BITMAP *buffer)
{
    BITMAP *temp;
    temp = create_sub_bitmap (buffer, rx, ry, rw, rh);
    gstream gs (temp);
    gs.set_wrap (true);
    gs << color(245) << msgs[current_message] << flush;
    destroy_bitmap (temp);
}

void Messager::setRect (int x, int y, int w, int h)
{
    rx = x;
    ry = y;
    rw = w;
    rh = h;
}

